package de.unisaarland.cs.st.tautoko.instrument;

import org.objectweb.asm.ClassAdapter;
import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.Opcodes;

public class ClassVisibilityClassAdapter extends ClassAdapter implements Opcodes {

	private int modifiers;
	
	private static final int CLEAR_MASK = Integer.MAX_VALUE - ACC_PROTECTED - ACC_PRIVATE;
	
	public ClassVisibilityClassAdapter(ClassVisitor parent) {
		this(parent, ACC_PUBLIC);
	}
	
	public ClassVisibilityClassAdapter(ClassVisitor parent, int modifiers) {
		super(parent);
		this.modifiers = modifiers;
	}

	@Override
	public void visit(int version, int access, String name, String signature, String superName, String[] interfaces) {
		access = access & CLEAR_MASK;
		access = access | modifiers;
		super.visit(version, access, name, signature, superName, interfaces);
	}
	
	public static void main(String[] args) {
		int access = ACC_ABSTRACT | ACC_PROTECTED | ACC_SYNCHRONIZED | ACC_SYNTHETIC;
		System.out.println(Integer.toBinaryString(access));
		access = access & CLEAR_MASK;
		access = access | ACC_PUBLIC;
		System.out.println(Integer.toBinaryString(access));
	}
	
}
