package de.unisaarland.cs.st.tautoko.miner;

import java.io.File;
import java.util.HashSet;
import java.util.regex.Pattern;

import org.objectweb.asm.Type;

import de.unisaarland.cs.st.adabu.core.state.ObjectState;
import de.unisaarland.cs.st.adabu.util.asm.MyType;


public class TypeSetDeepTransitiveModelMiner extends TypeStateMiner {

	private HashSet<String> acceptedTypes;

	public TypeSetDeepTransitiveModelMiner(File traceFile, int maxHeapPathLength, Pattern finalizerMethodPattern, HashSet<String> acceptedTypes) {
		super(traceFile, maxHeapPathLength, finalizerMethodPattern);
		this.acceptedTypes = acceptedTypes;
	}

	@Override
	protected boolean isInterestingObject(Integer objectId) {
		ObjectState objectState = getObjectState(objectId);
		if (objectState != null) {
			MyType type = objectState.getType();
			if (type.isComplexType()) {
				Type asmType = type.getAsmType();
				String className = asmType.getClassName().replace('.', '/');
				if (acceptedTypes.contains(className)) {
					return true;
				} else {
					return false;
				}
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

}
